import argparse


def args_parse():

    parser = argparse.ArgumentParser(description='Data-Model params')

    parser.add_argument("--data_name", help="Dataset", type=str, default="CIFAR10", choices=["CIFAR10", "TinyImageNet"])
    parser.add_argument("--seed", help="Seed", type=int, default=0)

    parser.add_argument("--train_epochs", help="model distillation training epoch", type=int, default=20)
    parser.add_argument("--train_batch", help="model distillation training batch", type=int, default=256)

    parser.add_argument("--feature_mode", help="embedding compute type", type=str, default="MinAD", choices=['MinAD', 'MinAD_KRM'])
    parser.add_argument("--attack_size", help="the number of attack samples per train batch", type=int, default=64)

    parser.add_argument("--num_attack_iter", help="number of iterations of MinAD", type=int, default=20)
    parser.add_argument("--num_evals_boundary", help="number of queries per iteration of MinAD", type=int, default=1000)
    parser.add_argument("--attack_lr_begin", help="initial LR of MinAD", type=float, default=16)
    parser.add_argument("--attack_lr_end", help="LR lower threshold of MinAD", type=float, default=0.2)

    return parser

